distributor

see the `distributor` page for the full documentation More...

Inheritance diagram for distributor:

## Public Types

typedef std::allocator< int >::size_type | size_type
typedef Vector< size_type > | _base
typedef _base::iterator | iterator
typedef _base::const_iterator | const_iterator
typedef int | tag_type
typedef communicator | communicator_type
Public Types inherited from Vector< std::allocator< int >::size_type >
typedef vector_rep< std::allocator< int >::size_type > | DATA
typedef DATA::iterator | iterator
typedef DATA::const_iterator | const_iterator
typedef DATA::pointer | pointer
typedef DATA::reference | reference
typedef DATA::const_reference | const_reference
typedef DATA::size_type | size_type
typedef DATA::difference_type | difference_type
typedef std::allocator< int >::size_type | value_type
typedef DATA::reverse_iterator | reverse_iterator
typedef DATA::const_reverse_iterator | const_reverse_iterator
Public Types inherited from smart_pointer< T >
typedef T | handled_type
typedef base::internal | internal

## Public Member Functions

| distributor (size_type dis_size=0, const communicator_type &c=communicator_type(), size_type loc_size=decide)
| distributor (const distributor &)
| ~distributor ()
void | resize (size_type dis_size=0, const communicator_type &c=communicator_type(), size_type loc_size=decide)
const communicator_type & | comm () const
size_type | dis_size () const
| global and local sizes More...
size_type | process () const
| current process id More...
size_type | n_process () const
| number of processes More...
size_type | find_owner (size_type dis_i) const
| find iproc associated to a global index dis_i: CPU=log(nproc) More...
size_type | first_index (size_type iproc) const
| global index range and local size owned by ip-th process More...
size_type | last_index (size_type iproc) const
size_type | size (size_type iproc) const
size_type | first_index () const
| global index range and local size owned by current process More...
size_type | last_index () const
size_type | size () const
bool | is_owned (size_type dis_i, size_type iproc) const
| true when dis_i in [first_index(iproc):last_index(iproc)[ More...
bool | is_owned (size_type dis_i) const
bool | operator== (const distributor &) const
bool | operator!= (const distributor &) const
Public Member Functions inherited from Vector< std::allocator< int >::size_type >
| Vector (size_type n=0, const std::allocator< int >::size_type &value=std::allocator< int >::size_type())
| Vector (const_iterator first, const_iterator last)
void | reserve (size_type n)
void | swap (Vector< std::allocator< int >::size_type > &x)
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
size_type | max_size () const
size_type | capacity () const
bool | empty () const
void | resize (size_type sz, std::allocator< int >::size_type v=std::allocator< int >::size_type())
const_reference | operator[] (size_type n) const
reference | operator[] (size_type n)
const_reference | at (size_type n) const
reference | at (size_type n)
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_back (const std::allocator< int >::size_type &x)
iterator | insert (iterator position, const std::allocator< int >::size_type &x=std::allocator< int >::size_type())
void | insert (iterator position, size_type n, const std::allocator< int >::size_type &x)
void | insert (iterator position, const_iterator first, const_iterator last)
void | pop_back ()
void | erase (iterator position)
void | erase (iterator first, iterator last)
Public Member Functions inherited from smart_pointer< T >
| smart_pointer (T *p=0)
| smart_pointer (void *count, internal i)
| smart_pointer (const smart_pointer< T > &x)
smart_pointer< T > & | operator= (const smart_pointer< T > &x)
| ~smart_pointer ()
Public Member Functions inherited from smart_pointer_base< T, details::constructor_copy< T > >
| smart_pointer_base (T *p=0)
| smart_pointer_base (const smart_pointer_base< T, details::constructor_copy< T > > &)
| smart_pointer_base (void *count, internal)
smart_pointer_base< T, details::constructor_copy< T > > & | operator= (const smart_pointer_base< T, details::constructor_copy< T > > &)
| ~smart_pointer_base ()
const T * | pointer () const
T * | pointer ()
const T & | data () const
T & | data ()
const T * | operator-> () const
T * | operator-> ()
const T & | operator* () const
T & | operator* ()
int | reference_counter () const
counter * | get_count () const

## Static Public Member Functions

static tag_type | get_new_tag ()
| returns a new tag More...

## Static Public Attributes

static const size_type | decide = size_type(-1)

## Protected Attributes

communicator_type | _comm

## Detailed Description

see the `distributor` page for the full documentation

Definition at line 62 of file distributor.h.

## Member Typedef Documentation

## size_type

typedef std::allocator<int>::size_type size_type

Definition at line 67 of file distributor.h.

## _base

typedef Vector<size_type> _base

Definition at line 68 of file distributor.h.

## iterator

typedef _base::iterator iterator

Definition at line 69 of file distributor.h.

## const_iterator

typedef _base::const_iterator const_iterator

Definition at line 70 of file distributor.h.

## tag_type

typedef int tag_type

Definition at line 71 of file distributor.h.

## communicator_type

typedef communicator communicator_type

Definition at line 72 of file distributor.h.

## Constructor & Destructor Documentation

## distributor() [1/2]

distributor | ( | size_type | dis_size = `0`,
|  | const communicator_type & | c = `communicator_type()`,
|  | size_type | loc_size = `decide`
| ) |  |

Definition at line 88 of file distributor.cc.

## distributor() [2/2]

distributor | ( | const distributor & | ownership | ) |

Definition at line 97 of file distributor.cc.

## ~distributor()

~distributor | ( |  | ) |

Definition at line 102 of file distributor.cc.

## Member Function Documentation

## resize()

void resize | ( | size_type | dis_size = `0`,
|  | const communicator_type & | c = `communicator_type()`,
|  | size_type | loc_size = `decide`
| ) |  |

Definition at line 30 of file distributor.cc.

## comm()

const distributor::communicator_type & comm | ( |  | ) | const

Definition at line 145 of file distributor.h.

## dis_size()

distributor::size_type dis_size | ( |  | ) | const

global and local sizes

Definition at line 207 of file distributor.h.

## process()

distributor::size_type process | ( |  | ) | const

current process id

Definition at line 179 of file distributor.h.

## n_process()

distributor::size_type n_process | ( |  | ) | const

number of processes

Definition at line 169 of file distributor.h.

## find_owner()

distributor::size_type find_owner | ( | size_type | dis_i | ) | const

find iproc associated to a global index dis_i: CPU=log(nproc)

Definition at line 106 of file distributor.cc.

## first_index() [1/2]

distributor::size_type first_index | ( | size_type | iproc | ) | const

global index range and local size owned by ip-th process

Definition at line 151 of file distributor.h.

## last_index() [1/2]

distributor::size_type last_index | ( | size_type | iproc | ) | const

Definition at line 157 of file distributor.h.

## size() [1/2]

distributor::size_type size | ( | size_type | iproc | ) | const

Definition at line 163 of file distributor.h.

## first_index() [2/2]

distributor::size_type first_index | ( |  | ) | const

global index range and local size owned by current process

Definition at line 189 of file distributor.h.

## last_index() [2/2]

distributor::size_type last_index | ( |  | ) | const

Definition at line 195 of file distributor.h.

## size() [2/2]

distributor::size_type size | ( |  | ) | const

Definition at line 201 of file distributor.h.

## is_owned() [1/2]

bool is_owned | ( | size_type | dis_i,
|  | size_type | iproc
| ) |  | const

true when dis_i in [first_index(iproc):last_index(iproc)[

Definition at line 213 of file distributor.h.

## is_owned() [2/2]

bool is_owned | ( | size_type | dis_i | ) | const

Definition at line 219 of file distributor.h.

## get_new_tag()

int get_new_tag | ( |  | ) |

static

returns a new tag

Definition at line 133 of file distributor.cc.

## operator==()

bool operator== | ( | const distributor & | x | ) | const

Definition at line 231 of file distributor.h.

## operator!=()

bool operator!= | ( | const distributor & | x | ) | const

Definition at line 225 of file distributor.h.

## Member Data Documentation

## decide

const size_type decide = size_type(-1)

static

Definition at line 76 of file distributor.h.

## _comm

communicator_type _comm

protected

Definition at line 137 of file distributor.h.

The documentation for this class was generated from the following files:

- /build/rheolef-FQTnje/rheolef-7.1/linalg/lib/distributor.h
- /build/rheolef-FQTnje/rheolef-7.1/linalg/lib/distributor.cc